using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Vintagestory.API.Client;
using Vintagestory.API.Common;
using Vintagestory.API.Common.Entities;
using Vintagestory.API.MathTools;

namespace Chess
{
    public class EntityPiece : EntityAgent
    {
        public override void OnInteract(EntityAgent byEntity, ItemSlot slot, Vec3d hitPosition, EnumInteractMode mode)
        {
            try {
            if (!this.Alive || this.World.Side == EnumAppSide.Client || mode == null)
            {
                base.OnInteract(byEntity, slot, hitPosition, mode);
                return;
            }

            EntityPlayer entityPlayer = byEntity as EntityPlayer;
            string agentUid = (entityPlayer != null) ? entityPlayer.PlayerUID : null;

            if (agentUid != null)
            {
		string type = this.Code.GetName();
                ItemStack stack = new ItemStack(byEntity.World.GetItem(new AssetLocation("creature-" + type)));
                if (!byEntity.TryGiveItemStack(stack))
                {
                    byEntity.World.SpawnItemEntity(stack, ServerPos.XYZ);
                }
                this.Die(0, null);
                return;
            }
            }
            catch {};
            base.OnInteract(byEntity, slot, hitPosition, mode);
        }
    }
}